<!-- =========================================================================================
    File Name: EnterVerificationCode.vue
    Description: Verification Code Page
========================================================================================== -->

<template>
  <div class="h-screen flex w-full bg-img">
    <div
      class="vx-col w-4/5 sm:w-4/5 md:w-3/5 lg:w-3/4 xl:w-3/5 mx-auto self-center"
    >
      <vx-card>
        <div slot="no-body" class="full-page-bg-color">
          <div class="vx-row">
            <!-- Image -->
            <div
              class="vx-col hidden sm:hidden md:hidden lg:block lg:w-1/2 mx-auto self-center"
            >
              <img
                src="@/assets/images/pages/forgot-password.png"
                alt="login"
                class="mx-auto"
              />
            </div>

            <div
              class="vx-col sm:w-full md:w-full lg:w-1/2 mx-auto self-center d-theme-dark-bg"
            >
              <div class="p-8">
                <div class="vx-card__title mb-8">
                  <!-- Title -->
                  <h4 class="mb-4">Nhập mã xác thực</h4>
                  <!-- Subtitle -->
                  <p>Chúng tôi vừa gửi mã OTP tới {{ this.email }}</p>
                </div>

                <!-- OTP Code -->
                <vs-input
                  v-validate="'required|digits:6'"
                  data-vv-validate-on="blur"
                  name="otp"
                  v-model="model.otpCode"
                  class="w-full"
                />
                <span class="text-danger text-sm" v-show="errors.has('otp')">{{
                  errors.first("otp")
                }}</span>

                <!-- Suggestion Text -->
                <div class="text-muted text-sm mb-8 mt-4">
                  Không nhận được mã? Vui lòng đợi trong vài phút.
                </div>

                <!-- Login Button -->
                <vs-button
                  type="border"
                  to="/pages/login"
                  class="px-4 w-full md:w-auto"
                >
                  <div class="inline-flex items-center">
                    <feather-icon
                      icon="ChevronsLeftIcon"
                      svgClasses="h-4 w-4 mr-1"
                    ></feather-icon
                    ><span>Đăng nhập</span>
                  </div>
                </vs-button>

                <!-- Verify Button -->
                <vs-button
                  class="float-right px-4 w-full md:w-auto mt-3 mb-8 md:mt-0 md:mb-0"
                  :disabled="!validateForm"
                  @click="verifyCode"
                  >Xác nhận</vs-button
                >

                <vs-divider>Hoặc</vs-divider>

                <!-- Resend Button -->
                <div class="text-center mb-8">
                  <router-link to="/pages/forgot-password"
                    >Gửi lại mã!</router-link
                  >
                </div>
              </div>
            </div>
          </div>
        </div>
      </vx-card>
    </div>
  </div>
</template>

<script>
import AuthenService from "../../services/AuthenService";
// For custom error message
import { Validator } from "vee-validate";

const dict = {
  custom: {
    otp: {
      required: "Vui lòng nhập mã OTP",
      digits: "Mã OTP phải là số và chứa chính xác 6 chữ số"
    }
  }
};

// register custom messages
Validator.localize("vi", dict);

export default {
  data() {
    return {
      model: {
        otpCode: "",
        email: ""
      }
    };
  },

  computed: {
    validateForm() {
      return !this.errors.any() && this.model.otpCode != "";
    }
  },

  created() {
    this.fetchData(this.$route.params.email);
  },

  methods: {
    fetchData(email) {
      this.model.email = email;
    },

    async verifyCode() {
      this.$globalBusyOn();
      try {
        await AuthenService.verifyCode(this.model);

        this.$router
          .push({
            name: "page-reset-password",
            params: { value: this.model }
          })
          .catch(() => {});
      } catch (error) {
        this.$error(error.message);
      } finally {
        this.$globalBusyOff();
      }
    }
  }
};
</script>
